<?php
/*********************************************************
 * @version    SVN: $Id$
 * @author     Rich Raffals
 ***********************************************************
 */
abstract class Form {
  protected $sRawQueryParam='';
  public $bStatus=FALSE;

  ///////////////////////////////////////////////////////////////////
  public function __construct( $queryParam=NULL ) {
  ///////////////////////////////////////////////////////////////////
    if (! empty($queryParam) ) {
      $this->sRawQueryParam = $queryParam;
    }
  }

  //
  // Methods
  //
  ///////////////////////////////////////////////////////////////////
  protected function reportError( $sMsg='Unknown Error' ) {
  ///////////////////////////////////////////////////////////////////
    $this->bStatus = FALSE;
    echo BR. "Please try again ($sMsg)";
    exit(1);
  }

  ///////////////////////////////////////////////////////////////////
  public function sanitize( $sParamName='Submitted Data' ) {
  ///////////////////////////////////////////////////////////////////
  // Generic sanitization to be done on any submitted field of a form:
  // Strips executable tags, trims white-space, flags XSS and buffer overflow attempts
    if ( ! empty($this->sRawQueryParam) ) {
      $safeQueryParam = strip_tags($this->sRawQueryParam); // strip all HTML/PHP tags and NUL bytes
      $safeQueryParam = trim($safeQueryParam, " \t\n\r\x0B"); // trim white-space

      if ( strlen($safeQueryParam) > 255 ) { // Protection against buffer overflow attempts
        $this->reportError("$sParamName is too long -- limit is 255 chars");
      }

      if ( preg_match('/[<>%]|ftp|telnet|ssh|href|document\.|window\./i', $safeQueryParam) ) { // XSS protection
        $this->reportError("Invalid, disallowed, or dangerous characters in $sParamName");
      }

      return $safeQueryParam;
    } // if (! empty($this->sRawQueryParam))

    $this->reportError("No $sParamName entered");
  } // sanitize()

}
?>
