<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>Demo Back-End Web Search Application (Object-Oriented PHP, MySQL, MVC -- and, to a lesser extent, HTML, HTML templating, and CSS)</title>
  
  <meta http-equiv="content-type" content="text/html; charset=utf-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=8" />
  <meta http-equiv="Page-Enter" content="revealTrans(Duration=2.0)" />
  <meta http-equiv="Page-Exit" content="revealTrans(Duration=3.0,Transition=23)" />

  <meta name="Author" content="Rich Raffals" />

  <meta name="aesop" content="sales" />
  <meta name="robots" content="index,follow" />
  <meta name="distribution" content="global" />
  <meta name="rating" content="general" />
  <meta name="security" content="public" />
  <meta name="revisit-after" content="10 days" />

  <!-- START Styles For Entire Site -->
  <!-- Default Settings For Cross-Browser Compatible CSS Starting Point -->
  <!-- <link rel="stylesheet" type="text/css" href="http://yui.yahooapis.com/2.8.0/build/reset-fonts-grids/reset-fonts-grids.css" />-->

  <!-- Main Layout -->
  <link href="css/layout.css" rel="stylesheet" type="text/css" />
  <!-- END Styles For Entire Site -->

  <!-- START Styles Specific To This Page -->
  <!-- END Styles Specific To This Page -->

  <!--  START JS Includes For Entire Site that NEED to be pre-loaded -->
  <!-- <script type="text/javascript" src="js/preSiteWideScripts.js"></script>-->
  <!--  END JS Includes For Entire Site that NEED to be pre-loaded -->
</head>

<body onload="document.getPage.webpageUrl.focus();">

<div id="wrapper">

<!-- START Header -->
  <div id="hd">
    Enter Website to Evaluate | <a href="search.php">Search</a>
  </div><!-- #hd -->
<!-- END Header -->

<!-- ***************************************************************************** -->

<!-- START Main Content -->
  <div id="mainContent">

    <h4><u>Demo Back-End Web Search Application</u><br />(coded in a few hours)</h4>
    
    <p><strong><u>Purpose</u></strong>: This basic web app was coded by hand, from scratch, solely to demonstrate programming skill with the following Back-End web technologies: <strong>Object-Oriented PHP, MySQL, MVC</strong> -- and, to a lesser extent, HTML, HTML templating, and CSS.&nbsp; Since the purpose of this particular app was to demonstrate coding proficiency with the PHP/MySQL technologies, no time was spent designing a snazzy UI for data display, nor was any time spent making this into a fancy AJAX application &mdash; in fact, no JavaScript at all was used, nor were any web frameworks of any kind.<br />
    </p>
    
    <p>(<em>To see a demo of my Front-End coding skills, including User Interface design and JavaScript/JSON/jQuery skills, see the <a href="../em">Smart Meter</a> app and click on the &quot;Info&quot; button.</em>)
    </p>

    <p>While this mini-project was done quickly, quality was not compromised: It was coded as a production-ready web application (save for making it pretty :).&nbsp; This means it is secure against hacking (eg, SQL-injection attacks, system/server attacks, XSS/Cross-Site Scripting attacks, buffer overflow attacks, etc), and is well-tested/debugged &mdash; even for corner cases.&nbsp; <em>(I encourage you to try to break or hack it, and/or to send me a critique of <a href="webSearch.tgz" target="_blank" title="Click to see the code and DB schema (gzipped tarball)">my code</a> if you write software. :)</em>.
    </p>

    <p>&quot;Production-ready&quot; to me also means including error detection and reporting, an unbreakable UI, and being implemented with solid software engineering practices (<a href="webSearch.tgz" target="_blank" title="Click to see the code and DB schema (gzipped tarball)">well-structured, maintainable, modular and well-commented code</a> that follows the Model-View-Controller design pattern).&nbsp; Of course, all the HTML and CSS validates and displays properly on all browsers.&nbsp; <strong><em>It represents the quality of database-driven, back-end functionality I could do for your project, even without using any web frameworks, in less than half a day.</em></strong>
    </p>

    <p><strong><u>How it works</u></strong>: Type in the URL of any website.&nbsp; When you click on &quot;Parse Webpage,&quot; the textual content of that web page will be examined by removing all the code, graphics, etc.&nbsp; Then, a tally of all the words longer than 3 characters found on that page will be presented, along with a count of how many times each word appears.&nbsp; The results will also be stored in a MySQL database.&nbsp; When you click on the &quot;Search&quot; link above, you will be able to type in a word and see all the web pages in the database where that word appears, and how many times it appears on each of those pages.&nbsp; Since this is just a quick demo, only HTML-based pages are supported.
    </p>

    <br />

    <form name="getPage" method="post" enctype="multipart/form-data" action="<?php echo $_SERVER['SCRIPT_NAME'] ?>">
      <label for="webpageUrl">Enter URL of HTML page to examine (HTTP/HTTPS protocols only)</label><br />
      <input id="webpageUrl" name="webpageUrl" type="text" size="80" value="" />
      <input name="submit" class="button" type="submit" value="Parse Webpage" />
    </form>
    
    <hr />

    <!-- Process user's form submission; put results in $oDataEntryForm -->
    <?php include 'Controller/processDataEntry.php' ?>

    <!-- Display url, total words, and then frequency of each word in table -->
    <?php if ( isset($oDataEntryForm) && ($oDataEntryForm->bStatus) ): ?>
        <?php require('templateFcns.php'); ?>

        URL: <?php echo $oDataEntryForm->url ?> &nbsp;--&nbsp; TOTAL WORDS: <?php echo $oDataEntryForm->totalWords ?><br />
        <br />
        <?php $aHeadings = array('Word', 'Count (case insensitive)'); ?>

        <!-- displayArrayAsHTMLtable() is a template fcn that's part of the View/Pres API -->
        <?php displayArrayAsHTMLtable($oDataEntryForm->aWordCount, $aHeadings) ?>
    <?php endif; ?>
    
  </div><!-- #mainContent -->
<!-- END Main Content -->

<!-- ***************************************************************************** -->

<!-- START Footer -->
  <div id="ft">
  </div><!-- #ft -->
<!-- END Footer -->

</div><!-- #wrapper -->

<!--  START JS Includes For Entire Site that DONT need to be pre-loaded -->
<!--<script type="text/javascript" src="js/jquery-1.4.2.min.js"></script>-->
<!--  END JS Includes For Entire Site that DONT need to be pre-loaded -->

</body>
</html>
